﻿Imports System.Web.Mvc
Imports HowDoICodeFirst.FluentMappings.Models

Namespace HowDoICodeFirst.FluentMappings.Controllers
	Public Class BlogController
		Inherits Controller
		Private db As New BlogContext()

		Public Function Index() As ViewResult
			Return View(db.Blogs.ToList())
		End Function

		Public Function Details(ByVal id As Integer) As ViewResult
			Dim blog = db.Blogs.Find(id)
			Return View(blog)
		End Function


		Public Function Create() As ActionResult
			Return View()
		End Function


		<HttpPost>
		Public Function Create(ByVal blog As Blog) As ActionResult
			If ModelState.IsValid Then
				db.Blogs.Add(blog)
				db.SaveChanges()
				Return RedirectToAction("Index")
			End If

			Return View(blog)
		End Function


		Public Function Edit(ByVal id As Integer) As ActionResult
			Dim blog = db.Blogs.Find(id)
			Return View(blog)
		End Function


		<HttpPost>
		Public Function Edit(ByVal blog As Blog) As ActionResult
			If ModelState.IsValid Then
				db.Entry(blog).State = EntityState.Modified
				db.SaveChanges()
				Return RedirectToAction("Index")
			End If
			Return View(blog)
		End Function


		Public Function Delete(ByVal id As Integer) As ActionResult
			Dim blog = db.Blogs.Find(id)
			Return View(blog)
		End Function


		<HttpPost, ActionName("Delete")>
		Public Function DeleteConfirmed(ByVal id As Integer) As ActionResult
			Dim blog = db.Blogs.Find(id)
			db.Blogs.Remove(blog)
			db.SaveChanges()
			Return RedirectToAction("Index")
		End Function
	End Class
End Namespace