﻿Imports System.Data.Entity
Imports System.Data.Entity.ModelConfiguration

Namespace HowDoICodeFirst.FluentMappings.Models
	Public Class BlogContext 'DbContext represents a session with the database
		Inherits DbContext
		Public Property Blogs() As DbSet(Of Blog)
		Public Property Posts() As DbSet(Of Post)
		Public Property Comments() As DbSet(Of Comment)

		Protected Overrides Sub OnModelCreating(ByVal modelBuilder As DbModelBuilder)
			modelBuilder.Entity(Of Blog)().ToTable("InternalBlogs")
			modelBuilder.Entity(Of Post)().Property(Function(p) p.Content).HasColumnName("Body")
			modelBuilder.Entity(Of Post)().Map(Sub(mc)
				mc.Properties(Function(p) New With {Key p.Id, Key p.Content, Key p.DateCreated, Key p.BlogId, Key p.Title})
				mc.ToTable("Posts")
			End Sub).Map(Sub(mc)
				mc.Properties(Function(p) New With {Key p.Id, Key p.Image})
				mc.ToTable("PostImage")
End Sub)
		End Sub
	End Class
	Public Class BlogContextInitializer
		Inherits DropCreateDatabaseIfModelChanges(Of BlogContext)
		Protected Overrides Sub Seed(ByVal context As BlogContext)


            Dim TempList = New List(Of Blog) _
                From {
             New Blog With {.BloggerName = "Julie", .Title = "My Code First Blog", .Posts = New List(Of Post) _
                        From {
             New Post With {.Title = "ForeignKeyAttribute Annotation", .DateCreated = Date.Now, .Content = "Mark navigation property with ForeignKey", .TagCloud = New List(Of Tag) _
                                From {
             New Tag With {.Name = "EF4.1"},
             New Tag With {.Name = "DbContext"}}}}},
             New Blog With {.BloggerName = "Ingemaar", .Title = "My Life as a Blog"},
             New Blog With {.BloggerName = "Sampson", .Title = "Tweeting for Dogs"}}

            TempList.ForEach(Function(b) context.Blogs.Add(b))



			MyBase.Seed(context)
		End Sub
	End Class
End Namespace




